/* This will create SRE2001.RXL : basic SRE2001
functions to be loaded into MacroSpace.  Run this if
you modify the source code of the library files (the .SRF files).
*/

parse arg doit .
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 say ' loading REXXLIB '
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
/*--------------   Load REXX libraries ----- */
/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs


names.0=0
procname_list=';DO NOT MODIFY this list of procedures in the SRE2001.RXL macrospace library '

say " Create SRE2001 macrospace procedure library. "
say " This requires that macrospace be cleared (which might effect"
say " other OS/2 programs)"

if doit=1 then signal go1
call charout,'  Enter 1 if you wish to proceed: '
parse pull gogo
if gogo<>1 then do
   say "Nothing done."
   exit
end
go1:
foo=macroclear()
if foo=0 then
    say "Warning: Problem clearing macrospace. "
else
  say "Macrospace cleared ... "


say "Loading  procedures "
retc=macroadd2('SRE_COMMAND','COMMAND.SRF','Before')
retc=macroadd2('SRE_SOCKIN','SOCKIN.SRF','Before')
retc=macroadd2('SRE_SOCK_NONCHUNK','BODYNON.SRF','Before')
retc=macroadd2('SRE_SOCK_CHUNK','BODYCHUN.SRF','Before')
retc=macroadd2('SRE_AUDIT','AUDITLOG.SRF','Before')
retc=macroadd2('SRE_CACHERECORD','CSHLOG.SRF','Before')
retc=macroadd2('SRE_CACHE','CACHEIT.SRF','Before')
retc=macroadd2('SRE_QUEUE','QUEUEIT.SRF','Before')
retc=macroadd2('SRE_QUEUE_STATS','QSTAT.SRF','Before')
retc=macroadd2('SRE_SAY','SRESAY.SRF','Before')
retc=macroadd2('SRE_SCREEN_WRITE','SCRWRITE.SRF','Before')

retc=macroadd2('SRE_TRACKIT','TRACKIT.SRF','Before')
retc=macroadd2('DATADIR','DATADIR.SRF','BEFORE')
retc=macroadd2('SRE_MD5','MD5D.SRF','Before')
retc=macroadd2('PACKUR','PACKUR.SRF','Before')
retc=macroadd2('COMPLETED','COMPLETD.SRF','Before')
retc=macroadd2('REQFIELD','REQFIELD.SRF','BEFORE') 
retc=macroadd2('STILL_ALIVE','ALIVE.SRF','BEFORE') 
retc=macroadd2('SRE_SYSVARS','SYSVAR.SRF','BEFORE') 

retc=macroadd2('CLIENTNAME','CLIENTNA.SRF','BEFORE')
retc=macroadd2('EXTRACT','EXTRACT.SRF','Before')
retc=macroadd2('CACHED','CACHED.SRF','Before')
retc=macroadd2('GMTOFFSET','GMTOFF.SRF','Before')
retc=macroadd2('PACK64','PACK64.SRF','Before')
retc=macroadd2('PACK64_MAKE','MKPACK64.SRF','Before')

retc=macroadd2('SERVER','SERVSOFT.SRF','Before')
retc=macroadd2('SRE_CONTROL','CONTROL.SRF','Before')
retc=macroadd2('SERVERNAME','SERVERNM.SRF','Before')
retc=macroadd2('ADD_TH','ADDTH.SRF','Before')
retc=macroadd2('SRE_DATESTAMP','GMTDATE.SRF','Before')
retc=macroadd2('SRE_ADDCOMMA','ADDCOMMA.SRF','Before')
retc=macroadd2('SRE_PAUSE','pause.SRF','Before')
retc=macroadd2('SRE_SHUTDOWN','shutdown.SRF','Before')
retc=macroadd2('SRE_CLIENTS','numcli.SRF','Before')
retc=macroadd2('SRE_COUNTVARS','ctvars.SRF','Before')
retc=macroadd2('SRE_EVENTVARS','eventvar.SRF','Before')
retc=macroadd2('SRE_VALUE','srevalue.srf','Before')

retc=macroadd2('SRE_HOSTINFO','hostinfo.srf','Before')
retc=macroadd2('SRE_REQUEST_ID_INFO','reqinfo.srf','Before')
retc=macroadd2('SRE_REQUEST_INFO','reqinfo1.srf','Before')
retc=macroadd2('SRE_WRITE_ERROR','writeerr.srf','Before')

retc=macroadd2('SRE_DMN_launch','sred_lau.SRF','Before')
retc=macroadd2('SRE_DMN_own','sred_own.SRF','Before')
retc=macroadd2('SRE_DMN_ask','sred_ask.SRF','Before')
retc=macroadd2('SRE_DMN_listen','sred_lis.SRF','Before')
retc=macroadd2('SRE_DMN_timeleft','sred_tim.SRF','Before')
retc=macroadd2('SRE_DMN_respond','sred_rsp.SRF','Before')
retc=macroadd2('SRE_DMN_command','sred_cmd.SRF','Before')
retc=macroadd2('SRE_DMN_monitor','sred_mon.SRF','Before')
retc=macroadd2('SRE_DMN_monitor_core','sred_mn2.SRF','Before')

retc=macroadd2('SRE_FLAG_open','flag_opn.SRF','Before')
retc=macroadd2('SRE_FLAG_set','flag_set.SRF','Before')
retc=macroadd2('SRE_FLAG_close','flag_clo.SRF','Before')

retc=macroadd2('SRE_LIST_open','list_opn.SRF','Before')
retc=macroadd2('SRE_LIST_set','list_set.SRF','Before')
retc=macroadd2('SRE_LIST_close','list_clo.SRF','Before')



        /************* END OF PROCEDURES ********/

/* now create procname list */
foo=sysfiledelete('SRE2001.IDX')
foo=stream('SRE2001.IDX','c','open write')
wow=charout('SRE2001.IDX',procname_list,1)
foo=stream('SRE2001.IDX','c','close')


say " saving macrospace procedures to SRE2001.RXL"
foo=macrosave('SRE2001.RXL')
if foo<>1 then 
   say "Error creating SRE2001.RXL : " foo
else
   say " success! "
exit


/****/
macroadd2:procedure expose procname_list
parse arg a1,a2,a3
procname_list=procname_list||'0d0a'x||a1
if stream(a2,'c','query exists')='' then 
   say "ERROR: could not find " a2
else
  foo=macroadd(a1,a2,a3)
return foo

